#ifndef __DIF_EVOL_H__
#define __DIF_EVOL_H__
//#include "stdafx.h"
#include <iostream>
#include <stdexcept>
#include <math.h>

	class Diferencialni
	{
	protected:
		double F; 
		double CR;
		int D; //počet parametrů fitness funkce
		int NP; //velikost jedné generace
		
		double **data;
		void init();
		double *Zkusebni;
		double **Meze;
		

	public:

		//--------------------------------Konstruktory------------------------
		inline Diferencialni();
		inline Diferencialni(int A);
		
		//-----------------------------Destruktor-----------------------
		~Diferencialni();

		//----------------------------Přístup k parametrům-------------------------- 
		inline double GetF();
		inline double GetCR();
		inline int GetD();
		inline int GetNP();

		//---------------------------Přenastavení parametrů---------------------------
		inline void SetF(float A);
		inline void SetCR(float A);
		void SetD(int A);
		void SetNP(int A);
		inline void SetMez(int A,int B,double C);
		

		//----------------------------Reprodukční algoritmus-----------------------------
		virtual void Reprodukce();
		virtual double Fitness(double* A);
		virtual void Elita(double* A);
		void Start_Evoluce();
		virtual double HodnotaElita();
		virtual double StandartDeviation();
		
	};

	//------------------------------Těla inline fukncí---------------------------
	Diferencialni::Diferencialni() : F(0.8) , CR(0.85) , D(2) , NP (10) , data (nullptr) 
	{init();}
	
	Diferencialni::Diferencialni(int A) : F(0.8) , CR(0.85) , D(A) , NP(A*10) , data(nullptr) 
	{init();}

	double Diferencialni::GetF() {return F;}

	double Diferencialni::GetCR() {return CR;}

	int Diferencialni::GetD() {return D;}

	int Diferencialni::GetNP() {return NP;}

	void Diferencialni::SetF(float A) {F = A;}

	void Diferencialni::SetCR(float A) {CR = A;}



	void Diferencialni::SetMez(int A,int B,double C) {Meze[A][B]=C;}
//}






#endif